#include <sourcemod>
#include <sdktools>
#include <magic_crystals>

new Handle:g_hCrystalCount = INVALID_HANDLE,
	Handle:g_hCrystalPrice = INVALID_HANDLE,
	count[MAXPLAYERS+1];
	
public Plugin:myinfo = 
{
	name = "Buy Crystals",
	author = "The End Is Near...",
	version = "1.2",
	url = "http://world-source.ru/"
};

public OnPluginStart()
{
	g_hCrystalCount = CreateConVar("mc_count", "1", "Укажите максимальное количество создаваемых кристаллов одним игроком");
	g_hCrystalPrice = CreateConVar("mc_price", "4000", "Укажите цену кристалла");

	HookEvent("player_spawn", Event_OnPlayerSpawn);
	
	RegConsoleCmd("crystal", CallBack);
	
	AutoExecConfig(true, "BuyCrystals", "MagicCrystal");
}

public Event_OnPlayerSpawn(Handle:event, const String:name[], bool:silent)
{
	count[GetClientOfUserId(GetEventInt(event, "userid"))] = 0;
}

public Action:CallBack(client, args)
{
	if (client > 0)
	{
		if (GetClientTeam(client) < 2)
		{
			ReplyToCommand(client, "[MagicCrystal] Вы должны присоединиться к команде");
		}
		else
		{
			if (!IsPlayerAlive(client))
			{
				ReplyToCommand(client, "[MagicCrystal] Вы должны быть живы");
			}
			else
			{
				new num = GetConVarInt(g_hCrystalCount);

				if (count[client] >= num)
				{
					ReplyToCommand(client, "[MagicCrystal] Достигнуто максимальное значение создания кристалла: %d", num);
				}
				else
				{
					new account = GetEntProp(client, Prop_Send, "m_iAccount"),
						price = GetConVarInt(g_hCrystalPrice);

					if (account < price)
					{
						ReplyToCommand(client, "[MagicCrystal] Недостаточно денег. Не хватает: %d", price - account);
					}
					else
					{
						decl Float:angles[3], Float:origin[3];
						GetClientAbsOrigin(client, origin); 
						origin[2] += 50.0;
						angles[0] = 0.0;
						angles[1] = -90.0;
						angles[2] = -90.0;

						if (CreateMagicCrystal(origin, angles))
						{
							ReplyToCommand(client, "[MagicCrystal] Кристалл успешно создан");
							SetEntProp(client, Prop_Send, "m_iAccount", account - price);
							count[client]++;
						}
						else
						{
							ReplyToCommand(client, "[MagicCrystal] Не удалось создать кристалл");
						}
					}
				}
			}
		}
	}
	return Plugin_Handled;
}